function M = tilde(V)
#This calculates the symplectic conjugate of a matrix: S'*T'*S
  rr = rows(V);
  cc = rows(V);
  if(rr!=cc)
    printf("? tilde: not a square matrix\n");
    M = V;
    return;
  endif;
  S = zeros(rr);
  n = 1;
  while n<rr
    S(n,n+1) = -1;
    S(n+1,n) = 1;
    n = n+2;
  endwhile;
  M = S'*V'*S;
end
