#!/usr/bin/python -u
##!/usr/bin/env python

# Thoughts on building a nudger widget.

import sys
import re
import math
import pygtk
pygtk.require('2.0')
import gtk

global nturns, m, ylog, lims, limlow, limhigh
nturns = 2
m = 8
ylog = False
lims = False
limlow = 0
limhigh = 0.5

def disectlog(x):
    if x==0: return [0.0,0]
    if x<0:
        sign = -1.0
    else:
        sign = 1.0
    lx = math.log10(abs(x))
    iexp = int(lx)
    mant = lx-iexp
    f = sign*10**mant
    return [f, iexp]

class nudger(gtk.HBox):
    name ="none"
    val = 0.0
    nudgeval = 0.0001
    lbl = ""
    ent = ""
    nudent = ""

    def delete_event(self, widget, event, data=None):
#        print "exit"
        return False
    def destroy(self, widget, data=None):
        gtk.main_quit()

    def readval(self, widget, entry):
        s = entry.get_text()
        self.val = float(entry.get_text())
#        s = "changed value to %f" % self.val
#        print s

    def readnudval(self, widget, entry):
        s = entry.get_text()
        self.nudgeval = float(entry.get_text())
#        s = "changed nudge value to %f" % self.nudgeval
#        print s

    def nudgeup(self, widget, entry):
        self.val = self.val+self.nudgeval
#        print self.val
        entry.set_text(str(self.val))

    def nudgedn(self, widget, entry):
        self.val = self.val-self.nudgeval
#        print self.val
        entry.set_text(str(self.val))

    def nudmul10(self, widget, entry):
        self.nudgeval = self.nudgeval*10.0
        entry.set_text(str(self.nudgeval))

    def nuddiv10(self, widget, entry):
        self.nudgeval = self.nudgeval/10.0
        entry.set_text(str(self.nudgeval))

    def __init__(self):
        gtk.HBox.__init__(self)

        lbl = gtk.Label(self.name)
        self.lbl = lbl
        self.pack_start(lbl, True, True, 2)

        ent = gtk.Entry(max=15)
        self.ent = ent
        ent.set_text(str(self.val))
        ent.connect("activate", self.readval, ent)
        self.pack_start(ent, False, False, 2)

        but = gtk.Button("Up")
        but.connect("clicked", self.nudgeup, ent)
        self.pack_start(but, True, True, 2)

        but = gtk.Button("Dn")
        but.connect("clicked", self.nudgedn, ent)
        self.pack_start(but, True, True, 2)

        nudent = gtk.Entry(max=10)
        self.nudent = nudent
        nudent.set_text(str(self.nudgeval))
        nudent.connect("activate", self.readnudval, nudent)
        self.pack_start(nudent, False, False, 2)

# Define spinners for nudger
#        spinfrac = gtk.SpinButton(None, 1, 10)
#        self.pack_start(spinfrac, False, False, 2)
#        adjexp = gtk.Adjustment(1, -10, 10, 1, 3, 0)
#        spinexp = gtk.SpinButton(adjexp, 1, 0)
#        self.pack_start(spinexp, False, False, 2)

        but = gtk.Button("<")
        but.connect("clicked", self.nudmul10, nudent)
        self.pack_start(but, False, False, 2)

        but = gtk.Button(">")
        but.connect("clicked", self.nuddiv10, nudent)
        self.pack_start(but, False, False, 2)


    def setname(self, n):
        self.name = n
        self.lbl.set_text(n)
    def setval(self, v):
        self.val = float(v)
        self.ent.set_text(str(self.val))
    def setnudgeval(self, v):
        self.nudgeval = float(v)
        self.nudent.set_text(str(self.nudgeval))
    def getname(self):
        v = self.lbl.get_text()
        return v
    def getval(self):
        v = self.ent.get_text()
        return v
    def getnudgeval(self):
        v = self.nudent.get_text()
        return v

def writebumps(self, bumps, ng):
    fw = open("test.bumps", "w")
    fw.write("nbumps %d\n" % len(bumps))
#    print "Number of nudgers is ", len(ng)
    i = 0
    for n in ng:
        nm = n.getname()
        v = n.getval()
        nv = n.getnudgeval()
        if nm[0:4]=="elt:":
            eltnm = re.split(" ", nm)
#            print eltnm[1], v, nv
            fw.write("%s %s %s\n" % (eltnm[1], v, nv))
        else:
#            print "name", nm, len(bumps[i][1]), v, bumps[i][0][3]
            fw.write("%s %s %s %s %s\n" % ("name", nm, len(bumps[i][1]), \
                                               v, bumps[i][0][3]))
            i = i+1
    fw.close()

    print "!cat tune.params tune.oct|octave"

#    print "!X86/nl_blspin fodo.param"
    print "yscl = 1000"
    print "ka = 0.0003*yscl"
    print "kb = -0.00*yscl"

    print 'set title "Orbit"'
    print 'set xlabel "s-s_{inj} [m]"'
    print 'set ylabel "orbit[mm]"'
    print 'plot "fodolat.key" us 1:($2*ka+kb) wi li ti "key" lt 2, "orbit.dat" us 1:($2*yscl) wi li ti "horiz" lt 1, "" us 1:($4*yscl) wi li ti "vert " lt 3'

# -- -- -- --
def writeparms(self, ng, poincare, nxx):
    fw = open("tune.params", "a")
#    print "Number of nudgers is ", len(ng)
    i = 0
    fw.write("kf1rot = 1\n")
    fw.write("quadmomdep = 1\n")
    fw.write("gam = 10.0\n")
    fw.write("frf = 199.1320427\n")
    fw.write("dL = 0\n")

    for n in ng:
        nm = n.getname()
        v = n.getval()
        nv = n.getnudgeval()

        fw.write("%s = %s\n" % (nm, v))
    fw.close()

    print "!cat tune.params tune.oct|octave"
    if poincare==1:
        print "!octave <tune-fft.oct"

# -- -- -- --
def trackit(self, ng):
    global nturns
    fw = open("tune.params", "w")
    fw.write("poincare = 0\n")
    fw.write("nturns = %s\n" %nturns)
    fw.close()

    writeparms(self, ng, 0, nturns)
# -- -- -- --
def get_turns(self, widget):
    global nturns
    nturns = entry.get_text()
# -- -- -- --
def poincit(self, ng):
    global m
    fw = open("tune.params", "w")
    fw.write("poincare = 1\n")
    fw.write("m = %s\n" %m)
    nturns = 2**int(float(m))
    fw.write("nturns = %s\n" %nturns)
    fw.close()

    writeparms(self, ng, 1, m)
# -- -- -- --
def get_m(self, widget):
    global m
    m = entry.get_text()
# -- -- -- --
def trackplot(self, xyz):
    print "unset key"
    print "set grid"
    print "unset logscale y"
    print 'set xlabel "s [m]"'
    if xyz=="x":
        print 'set ylabel "x [m]"'
        print 'plot "tune.dat" using 1:3 wi lines'
    else:
        if xyz=="y":
            print 'set ylabel "y [m]"'
            print 'plot "tune.dat" using 1:5 wi lines'
        else:
            print 'set ylabel "delta"'
            print 'plot "tune.dat" using 1:8 wi lines'

# -- -- -- --
def poincplot(self, xyz):
    print "unset key"
    print "set grid"
    print "unset logscale y"
    if xyz[0]=="x":
        print 'set xlabel "x [m]"'
        print 'set ylabel "xp"'
        print 'plot "tune.poi" using 3:4'
    else:
        if xyz[0]=="y":
            print 'set xlabel "y [m]"'
            print 'set ylabel "yp"'
            print 'plot "tune.poi" using 5:6'
        else:
            print 'set xlabel "z [m]"'
            print 'set ylabel "delta"'
            print 'plot "tune.poi" using 7:8'

# -- -- -- --
def fftplot(self, hvz):
    global m, ylog, lims
    if ylog:
        print 'set logscale y'
    else:
        print 'unset logscale y'
    print "unset key"
    print "set grid"
    print 'set xlabel "fractional %s tune"' %hvz
    print 'set ylabel "amplitude"'

    if lims:
        limstr = '[%s:%s]' %(limlow, limhigh)
    else:
        limstr = "[:]"

    if hvz=="H":
        col = 4
    else:
        if hvz=="V":
            col = 7
        else:
            col = 10
    pstr = 'plot %s "tune.fft" using ($1/2.0**%s):%s wi li' %(limstr, m, col)
    print pstr

# -- -- -- --
def logclick(self):
    global ylog
    ylog = not ylog
# -- -- -- --
def limclick(self):
    global lims
    lims = not lims
# -- -- -- --
def getlim(self, ud):
    global limlow, limhigh
    if ud==0:
        limlow  = entry.get_text()
    else:
        limhigh = entry.get_text()
# -- -- -- --
def epsplot(self):
    print 'set term postscript eps color "Times-Roman" 20'
    print 'set output "tune.eps"'
    print 'replot'
    print 'unset output'
    print 'set term wxt'
#==========================
if __name__ == "__main__":

    window = gtk.Window()
    window.connect("destroy", gtk.main_quit)
    window.set_border_width(1)

    vbox = gtk.VBox(False, 2)
    window.add(vbox)

# Build the nudgers for the list of parameters
#    global ng
    ng = []
    k = 0
    parms = [["kf", 0.25, 0.01],
             ["      kf1ang", 0, 0.001],
             ["kd", -0.3, 0.01],
             ["sf", 0, 0.001],
             ["sd", 0, 0.001],
             ["x0", 0.001, 0.001],
             ["xp0", 0, 0.0001],
             ["y0", 0.001, 0.001],
             ["yp0", 0., 0.0001],
             ["z0", 0., 0.001],
             ["delta0", 0.001, 0.001],
             ["krf", 0.01, 0.01]]

    for p in parms:
        ng.append(nudger())
        tnm = p[0]
        ng[k].setname(tnm)
        ng[k].setval(p[1])
        ng[k].setnudgeval(p[2])
        vbox.pack_start(ng[k])
        k = k+1

    #window.add(vbox2)
#    wout2 = gtk.Button("calc: track vs s")
    
    trk = gtk.HBox(False, 2)
    vbox.add(trk)
    ptrk = gtk.HBox(False, 2)
    vbox.add(ptrk)

    wout = gtk.Button("calc: track vs s")
    wout.connect("clicked", trackit, ng)
    wout.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("#FFFF00"))
    trk.add(wout)
    lbl = gtk.Label("nturns: ")
    trk.add(lbl)
    entry = gtk.Entry()
    entry.connect("activate", get_turns, entry)
    entry.set_text("2")
    trk.pack_start(entry, False, False, 0)

    wout = gtk.Button("x vs s")
    wout.connect("clicked", trackplot, "x")
    wout.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("#00AA00"))
    trk.add(wout)
    wout = gtk.Button("y vs s")
    wout.connect("clicked", trackplot, "y")
    wout.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("#00AA00"))
    trk.add(wout)
    wout = gtk.Button("delta vs s")
    wout.connect("clicked", trackplot, "z")
    wout.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("#00AA00"))
    trk.add(wout)

    wout = gtk.Button("poincare: track vs s")
    wout.connect("clicked", poincit, ng)
    wout.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("#FFFF00"))
    ptrk.add(wout)
    lbl = gtk.Label("(2^m) m: ")
    ptrk.add(lbl)
    entry = gtk.Entry()
    entry.connect("activate", get_m, entry)
    entry.set_text('%d'%m)
    ptrk.pack_start(entry, False, False, 0)
    
    wout = gtk.Button("x vs s")
    wout.connect("clicked", poincplot, "x vs x'")
    wout.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("#00AA00"))
    ptrk.add(wout)
    wout = gtk.Button("y vs s")
    wout.connect("clicked", poincplot, "y vs y'")
    wout.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("#00AA00"))
    ptrk.add(wout)
    wout = gtk.Button("z vs delta")
    wout.connect("clicked", poincplot, "z vs delta")
    wout.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("#00AA00"))
    ptrk.add(wout)

    fft = gtk.HBox(False, 1)
    vbox.add(fft)
    wout = gtk.Label("FFT's:")
    fft.add(wout)

    wout = gtk.Button("H")
    wout.connect("clicked", fftplot, "H")
    wout.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("#00AA00"))
    fft.add(wout)
    wout = gtk.Button("V")
    wout.connect("clicked", fftplot, "V")
    wout.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("#00AA00"))
    fft.add(wout)
    wout = gtk.Button("Z")
    wout.connect("clicked", fftplot, "Z")
    wout.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("#00AA00"))
    fft.add(wout)
    lgb = gtk.CheckButton("logy", ylog)
    lgb.connect("toggled", logclick)
    fft.add(lgb)

    limts = gtk.CheckButton("limits", lims)
    limts.connect("toggled", limclick)
    fft.add(limts)
    llow = gtk.Entry()
    llow.set_text("%f" %limlow)
    llow.connect("activate", getlim, 0)
    fft.add(llow)
    lhi  = gtk.Entry()
    lhi.set_text("%f" %limhigh)
    lhi.connect("activate", getlim, 1)
    fft.add(lhi)

    wout = gtk.Button("Postscript of last plot")
    wout.connect("clicked", epsplot)
    wout.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("#00AAAA"))
    vbox.add(wout)

    quit = gtk.Button("Quit")
    quit.connect("clicked", gtk.main_quit, None)
    quit.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("#FF0000"))
    vbox.pack_start(quit, True, True, 2)

    window.show_all()
    gtk.main()
