#!/usr/bin/wish -f
# A TCL script to make various plots via gnuplot for the split2 program.

proc plot1var {file c lim mn mx} {
    if {$lim == 0} {
	set strng "plot \"$file\" using 0:$c"
    } else {
	set strng "plot \[$mn:$mx\] \"$file\" using 0:$c"
    }
    exec <@stdin >@stdout echo $strng
}

proc plot2var {file c1 c2 lim mn mx} {
    if {$lim == 0} {
	set strng "plot \"$file\" using 0:$c1, \"$file\" using 0:$c2"
    } else {
      set strng "plot \[$mn:$mx\] \"$file\" using 0:$c1, \"$file\" using 0:$c2"
    }
    exec <@stdin >@stdout echo $strng
}

proc plot1vs2var {file c1 c2} {
    set strng "plot \"$file\" using $c1:$c2"
    exec <@stdin >@stdout echo $strng
}
proc psplot {} {
    exec <@stdin >@stdout echo {set term postscript}
    exec <@stdin >@stdout echo {set output "spill2.ps"}
    exec <@stdin >@stdout echo {replot}
    exec <@stdin >@stdout echo {set term x11}
    exec <@stdin >@stdout echo {set output "stdout"}
}
#---------------------------------------
frame .b3
pack .b3 -fill x

checkbutton .b3.lim -text limits -variable b3lim -relief flat

entry .b3.lim_min -width 10 -relief sunken -bd 2 -textvariable b3_lim_min
label .b3.to -text "to"
entry .b3.lim_max -width 10 -relief sunken -bd 2 -textvariable b3_lim_max

button .b3.plot -text "<x>, sigma_x" -command {upvar 0 b3lim lim; \
	upvar 0 b3_lim_min mn;\
	upvar 0 b3_lim_max mx;\
	plot2var ave_orbit.out 1 2 $lim $mn $mx}

pack .b3.plot .b3.lim .b3.lim_min .b3.to .b3.lim_max -side left -fill x
#---------------------------------------
frame .b1
pack .b1 -fill x

checkbutton .b1.lim -text limits -variable b1lim -relief flat

entry .b1.lim_min -width 10 -relief sunken -bd 2 -textvariable b1_lim_min
label .b1.to -text "to"
entry .b1.lim_max -width 10 -relief sunken -bd 2 -textvariable b1_lim_max

button .b1.plot -text "<x>" -command {upvar 0 b1lim lim; \
	upvar 0 b1_lim_min mn;\
	upvar 0 b1_lim_max mx;\
	plot1var ave_orbit.out 1 $lim $mn $mx}

pack .b1.plot .b1.lim .b1.lim_min .b1.to .b1.lim_max -side left -fill x

#---------------------------------------
frame .b2
pack .b2 -fill x

checkbutton .b2.lim -text limits -variable b2lim -relief flat

entry .b2.lim_min -width 10 -relief sunken -bd 2 -textvariable b2_lim_min
label .b2.to -text "to"
entry .b2.lim_max -width 10 -relief sunken -bd 2 -textvariable b2_lim_max

button .b2.plot -text "sigma_x" -command {upvar 0 b2lim lim; \
	upvar 0 b2_lim_min mn;\
	upvar 0 b2_lim_max mx;\
	plot1var ave_orbit.out 2 $lim $mn $mx}

pack .b2.plot .b2.lim .b2.lim_min .b2.to .b2.lim_max -side left -fill x

#---------------------------------------
frame .b4
pack .b4 -fill x

button .b4.plot -text "<x> vs sigma_x" -command {\
	plot1vs2var ave_orbit.out 1 2}

pack .b4.plot -fill x
#---------------------------------------
frame .b5
pack .b5 -fill x

button .b5.plot -text "phi vs W" -command {\
	exec <@stdin >@stdout echo {plot "baccsr.out" using 1:2, "separatrix.out" using 1:2 with lines}}

pack .b5.plot -fill x
#---------------------------------------
frame .b6
pack .b6 -fill x

button .b6.plot -text "x vs x'" -command {\
	plot1vs2var baccsr.out 3 4}

pack .b6.plot -fill x
#---------------------------------------
button .ps -text "PostScript of last plot" -command \
    {psplot}
pack .ps -fill x
#---------------------------------------
button .quit -text "quit" -command exit
pack .quit -fill x

.b1.plot configure -bg Red4 -fg yellow
.b2.plot configure -bg Red4 -fg yellow
.b3.plot configure -bg SeaGreen -fg yellow
.b4.plot configure -bg Red4 -fg yellow
.b5.plot configure -bg SeaGreen -fg yellow
.b6.plot configure -bg SeaGreen -fg yellow
.ps configure -bg Blue -fg cyan
.quit configure -bg Red4 -fg yellow


