// $Header: $
// mat3.hxx  a 3x3 matrix class

#ifndef mat3_h
#define mat3_h 1

#include <iostream>

#ifndef mat3_lib_goober
//extern wstring mat3_format;
#else
//wstring mat3_format = " %11.6lf";
#endif

const int MAT3DIM = 3;

//=====================
class mat3	// a matrix class
{
public:
  double m[MAT3DIM][MAT3DIM];
//-- -- -- -- -- -- --
// constructors:
  mat3()
    {
      unit();  // default to a unit matrix
    }

// Member functions, etc.
  mat3 unit();
  mat3 zero();
  mat3 &operator=(const mat3 &A);
  mat3 operator*(const mat3 &A) const;
  mat3 operator+(const mat3 &A) const;
  mat3 operator-(const mat3 &A) const;
  friend std::ostream &operator<<(std::ostream & os, const mat3 &m);
  friend mat3 transpose(const mat3 &M);
  friend double trace(const mat3 &M);
  friend double det(const mat3 &M);
  friend mat3 inverse(const mat3 &M);
};
#endif
