// $Header: $
// mat6.cxx

#include <iostream>
#include <stdio.h>
#include <stdlib.h>

#define mat6_lib_goober 1
#include "mat6/mat6.hxx"

// Functions for "mat6" class

//=====================
mat6 mat6::unit()
{
  int i, j;
  for(i=0;i<MAT6DIM;i++)
    {
      for(j=0;j<MAT6DIM;j++)
	{
	if(i==j)m[i][j] = 1;
	else m[i][j] = 0;
	}
    }
  return *this;
}
//-- -- -- -- -- --
mat6 mat6::zero()
{
  int i, j;
  for(i=0;i<MAT6DIM;i++)
    {
      for(j=0;j<MAT6DIM;j++)
	{
	  m[i][j] = 0;
	}
    }
  return *this;
}
//-- -- -- -- -- --
mat6 &mat6::operator=(const mat6 &A)
{
  int i,j;

  for(i=0;i<MAT6DIM;i++)
    {
      for(j=0;j<MAT6DIM;j++)
        {
          m[i][j] = A.m[i][j];
        }
    }
  return *this;
}
//-- -- -- -- -- --
mat6 mat6::operator*(const mat6 &A) const
{
  int i,j,k;
  mat6 C;

  for(i=0;i<MAT6DIM;i++)
    {
      for(j=0;j<MAT6DIM;j++)
        {
          C.m[i][j] = 0;
          for(k=0;k<MAT6DIM;k++)
            {
              C.m[i][j] += m[i][k] * A.m[k][j];
            }
        }
    }
  return C;
}
//-- -- -- -- -- --
mat6 mat6::operator+(const mat6 &A) const
{
  int i,j;
  mat6 C;

  for(i=0;i<MAT6DIM;i++)
    {
      for(j=0;j<MAT6DIM;j++)
        {
          C.m[i][j] = m[i][j]+A.m[i][j];
        }
    }
  return C;
}
//-- -- -- -- -- --
mat6 mat6::operator-(const mat6 &A) const
{
  int i,j;
  mat6 C;

  for(i=0;i<MAT6DIM;i++)
    {
      for(j=0;j<MAT6DIM;j++)
        {
          C.m[i][j] = m[i][j]-A.m[i][j];
        }
    }
  return C;
}
//-- -- -- -- -- --
std::ostream &operator<<(std::ostream & os, const mat6 &A)
{
  int i,j;
  char numstr[50];

  for(i=0;i<MAT6DIM;i++)
    {
      os << "\t[ ";
      for(j=0;j<MAT6DIM;j++)
        {
	  //          sprintf(numstr, (char*)mat6_format, A.m[i][j]);
          sprintf(numstr, "%11.6lf", A.m[i][j]);
          os << numstr;
        }
      os << " ]\n";
    }
  return os;
}
//-- -- -- -- -- --
mat6 transpose(const mat6 &M)
{
  int i,j;
  mat6 A;
  for(i=0;i<MAT6DIM;i++)
    {
      for(j=0;j<MAT6DIM;j++)
	{
	  A.m[i][j] = M.m[j][i];
	}
    }
  return A;
}
//-- -- -- -- -- --
double trace(const mat6 &M)
{
  int i;
  double t;
  t = 0;
  for(i=0;i<MAT6DIM;i++)
    {
      t += M.m[i][i];
    }
  return t;
}
//-- -- -- -- -- --
