#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <malloc.h>

#include <iostream>

#include "mat6/mat6.hxx"

#include <string>

char endl = '\n';

const int exppow = 20;


const double randnorm = 1.0/(double)RAND_MAX;

//=====================
double frand()
{// Returns a real number between 0 and 1.
  return (double)rand()*randnorm;
}
//---------------------
int main(int argc, char** argv)
{
  mat6 A, AA, B, C, S6;
  int i, j, k;

  S6.m[0][1] = -1.0;
  S6.m[1][0] =  1.0;
  S6.m[2][3] = -1.0;
  S6.m[3][2] =  1.0;
  S6.m[4][5] = -1.0;
  S6.m[5][4] =  1.0;
  for(i=0;i<6;i++) S6.m[i][i] = 0.0;

  std::cout << "S6:\n" << S6;

  for(i=0;i<6;i++)
    {
      for(j=i;j<6;j++)
	{
	  A.m[i][j] = frand();
	  if(i!=j) A.m[j][i] = A.m[i][j];
	}
    }
  std::cout << "A:\n" << A  << endl;
  AA = (-1.0)*S6*A;
  std::cout << "AA = -S*A:\n" << AA << endl;

  B = exp6((-1.0)*S6*A, exppow);
  std::cout << "B = exp(-S6*A):\n" << B << endl;
  C = transpose(B)*S6*B-S6;
  std::cout << "C = transpose(B)*S6*B-S6:\n" << C << endl;

  return 0;
}
