#!/usr/bin/env gnuplot

scl = 1.0e6

set grid

set xlabel "random seed #"
set ylabel "x position [{/Symbol m}m]"

sigx = 66.2

set term post eps enh sol col "Times-Roman" 25
set output "IPvsseeds.eps"
plot "test.dat" us 0:($4*scl) ti "IP8 no cor", "" us 0:($5*scl) ti "IP8 cor" wi linespo, "" us 0:($6*scl) ti "IP6 no cor", "" us 0:($7*scl) ti "IP6 cor" wi linespo, +sigx ti "" lt 7, -sigx ti "" lt 7

set output "IPcorrvsseeds.eps"
ylim = 10
plot [][-ylim:ylim] "test.dat" us 0:($5*scl) ti "IP8 cor" wi linespo, "" us 0:($7*scl) ti "IP6 cor" wi linespo



set output "sigma_xvsseed.eps"
set ylabel "{/Symbol s}_{/Times-Italic x} [{/Symbol m}m] averaged around ring"
set logscale y
plot "test.dat" us 0:($2*scl) ti "Uncorrected", "" us 0:($3*scl) ti "Corrected" wi linespo lt 3

unset logscale y

set output "maxcorvsseed.eps"

f(x,y) = -y>x ? -y : x

set output "maxcorvsseed.eps"
unset key
#set ylabel "max corrector strength [{/Symbol m}r]"
set ylabel "max(|{/Symbol q}_{/Times-Italic j}|) [{/Symbol m}r]"
plot "test.dat" us 0:(f($9*scl,$11*scl)) ti "+" wi li

set output "maxIcorvsseed.eps"
unset key
set ylabel "max corrector current change |{/Symbol D}{/Times-Italic I}| [A]"
plot "test.dat" us 0:(f($9,$11)*50/(0.285/833)) ti "+" wi li

set output "maxorbvsseed.eps"
set ylabel "extreme orbit deviation after correction [{/Symbol m}m]"
plot "test.dat" us 0:($12*(scl)) wi po

set output "maxorbuncvsseed.eps"
set ylabel "extreme orbit deviation uncorrected [{/Symbol m}m]"
plot "test.dat" us 0:($13*(scl)) wi po
