#!/usr/bin/env gnuplot
set grid

yscl = 1000
ka = 0.00005*yscl
kb = -0.00*yscl

set title "Example of misaligned quads with triplet orbit correction"
set xlabel "s-s_{inj} [m]"
set ylabel "horizontal orbit[mm]"

set term post eps enh solid color "Times-Roman" 25
set output "misalign+cor.eps"

plot "../xend-key.dat" us 1:($2*ka+kb) wi li ti "" lt 2, "orbit-bad.dat" us 1:($2*yscl) wi li ti "misaligned" lt 1, "orbit-cor.dat" us 1:($2*yscl) wi li ti "corrected" lt 3

set output "misalign-quad.eps"
set title "Quad misalignments around ring for typical seed"
set xlabel "Quad number starting with bo6-qd1"
set ylabel "Offset [{/Symbol m}m]"
set xtics 41
unset key
# note, I used a scaleoffset of 3 for 3um maximum shifts
plot "qoffsets.dat" us 0:($2*3) wi imp lw 2
