#!/usr/bin/python -u
##!/usr/bin/env python

# Thoughts on building a nudger widget.

import sys
import re
import math
import pygtk
pygtk.require('2.0')
import gtk

def disectlog(x):
    if x==0: return [0.0,0]
    if x<0:
        sign = -1.0
    else:
        sign = 1.0
    lx = math.log10(abs(x))
    iexp = int(lx)
    mant = lx-iexp
    f = sign*10**mant
    return [f, iexp]

class nudger(gtk.HBox):
    name ="none"
    val = 0.0
    nudgeval = 0.0001
    lbl = ""
    ent = ""
    nudent = ""

    def delete_event(self, widget, event, data=None):
#        print "exit"
        return False
    def destroy(self, widget, data=None):
        gtk.main_quit()

    def readval(self, widget, entry):
        s = entry.get_text()
        self.val = float(entry.get_text())
#        s = "changed value to %f" % self.val
#        print s

    def readnudval(self, widget, entry):
        s = entry.get_text()
        self.nudgeval = float(entry.get_text())
#        s = "changed nudge value to %f" % self.nudgeval
#        print s

    def nudgeup(self, widget, entry):
        self.val = self.val+self.nudgeval
#        print self.val
        entry.set_text(str(self.val))

    def nudgedn(self, widget, entry):
        self.val = self.val-self.nudgeval
#        print self.val
        entry.set_text(str(self.val))

    def nudmul10(self, widget, entry):
        self.nudgeval = self.nudgeval*10.0
        entry.set_text(str(self.nudgeval))

    def nuddiv10(self, widget, entry):
        self.nudgeval = self.nudgeval/10.0
        entry.set_text(str(self.nudgeval))

    def __init__(self):
        gtk.HBox.__init__(self)

        lbl = gtk.Label(self.name)
        self.lbl = lbl
        self.pack_start(lbl, True, True, 2)

        ent = gtk.Entry(max=15)
        self.ent = ent
        ent.set_text(str(self.val))
        ent.connect("activate", self.readval, ent)
        self.pack_start(ent, False, False, 2)

        but = gtk.Button("Up")
        but.connect("clicked", self.nudgeup, ent)
        self.pack_start(but, True, True, 2)

        but = gtk.Button("Dn")
        but.connect("clicked", self.nudgedn, ent)
        self.pack_start(but, True, True, 2)

        nudent = gtk.Entry(max=10)
        self.nudent = nudent
        nudent.set_text(str(self.nudgeval))
        nudent.connect("activate", self.readnudval, nudent)
        self.pack_start(nudent, False, False, 2)

# Define spinners for nudger
#        spinfrac = gtk.SpinButton(None, 1, 10)
#        self.pack_start(spinfrac, False, False, 2)
#        adjexp = gtk.Adjustment(1, -10, 10, 1, 3, 0)
#        spinexp = gtk.SpinButton(adjexp, 1, 0)
#        self.pack_start(spinexp, False, False, 2)

        but = gtk.Button("<")
        but.connect("clicked", self.nudmul10, nudent)
        self.pack_start(but, False, False, 2)

        but = gtk.Button(">")
        but.connect("clicked", self.nuddiv10, nudent)
        self.pack_start(but, False, False, 2)


    def setname(self, n):
        self.name = n
        self.lbl.set_text(n)
    def setval(self, v):
        self.val = float(v)
        self.ent.set_text(str(self.val))
    def setnudgeval(self, v):
        self.nudgeval = float(v)
        self.nudent.set_text(str(self.nudgeval))
    def getname(self):
        v = self.lbl.get_text()
        return v
    def getval(self):
        v = self.ent.get_text()
        return v
    def getnudgeval(self):
        v = self.nudent.get_text()
        return v

def writebumps(self, bumps, ng):
    fw = open("test.bumps", "w")
    fw.write("nbumps %d\n" % len(bumps))
#    print "Number of nudgers is ", len(ng)
    i = 0
    for n in ng:
        nm = n.getname()
        v = n.getval()
        nv = n.getnudgeval()
        if nm[0:4]=="elt:":
            eltnm = re.split(" ", nm)
#            print eltnm[1], v, nv
            fw.write("%s %s %s\n" % (eltnm[1], v, nv))
        else:
#            print "name", nm, len(bumps[i][1]), v, bumps[i][0][3]
            fw.write("%s %s %s %s %s\n" % ("name", nm, len(bumps[i][1]), \
                                               v, bumps[i][0][3]))
            i = i+1
    fw.close()
    print "!X86/nl_blspin fodo.param"
    print "yscl = 1000"
    print "ka = 0.0003*yscl"
    print "kb = -0.00*yscl"

    print 'set title "Orbit"'
    print 'set xlabel "s-s_{inj} [m]"'
    print 'set ylabel "orbit[mm]"'
    print 'plot "fodolat.key" us 1:($2*ka+kb) wi li ti "key" lt 2, "orbit.dat" us 1:($2*yscl) wi li ti "horiz" lt 1, "" us 1:($4*yscl) wi li ti "vert " lt 3'


#==========================
if __name__ == "__main__":

# Start by reading in bump file and building the list
    bumpslist = []
    bumps = []
    nbumps = 0
    i = 0
    for line in open("test.bumps"):
        if len(line)>1 and line[0:1]!="#":
            line = re.split("\n", line)[0]
            parts = re.split("[ \t\n,:]", line)
            xx = []
            for x in parts:
                if len(x)>0: xx.append(x)
#            print xx
            if xx[0]=='nbumps':
                if nbumps!=0:
                    print "# Got a second 'nbumps' line!"
                nbumps = int(xx[1])
            else:
                if xx[0]=="name":
                    bumpslist.append(xx[1:5])
#                    print bumpslist[i]
                    i = i+1
                    j = 0
                    y = []
                else:
                    if bumpslist[i-1][1]>j:
                        y.append(xx[0:3])
                        j = j+1
#                        print j, y[j-1], bumpslist[i-1][1]
                        if j==int(bumpslist[i-1][1]):
                            bumps.append([bumpslist[i-1],y])

#    print bumps[0][0][0]
#    print len(bumps)
#    for b in bumps:
#        print b

    window = gtk.Window()
    window.connect("destroy", gtk.main_quit)
    window.set_border_width(1)

    vbox = gtk.VBox(False, 2)
    window.add(vbox)

# Build the nudgers for the list of bumps

    ng = []
    k = 0
    for b in bumps:
        ng.append(nudger())
        ng[k].setname(b[0][0])
        ng[k].setval(float(b[0][2]))
        ng[k].setnudgeval("0.0001")
        vbox.pack_start(ng[k])
        k = k+1
        for trims in b[1]:
#            print trims
            ng.append(nudger())
            tnm = "elt: "+trims[0]
            ng[k].setname(tnm)
            ng[k].setval(float(trims[1]))
            ng[k].setnudgeval(float(trims[2]))
            vbox.pack_start(ng[k])
            k = k+1

    wout = gtk.Button("Write 'test.bumps'")
    wout.connect("clicked", writebumps, bumps, ng)
    vbox.add(wout)

    quit = gtk.Button("Quit")
    quit.connect("clicked", gtk.main_quit, None)
    vbox.pack_start(quit, True, True, 2)

    window.show_all()
    gtk.main()
